<?xml version="1.0"?>
<!--
** Module   : adm_templates.tpl
** Abstract : AST templates used for generating code from ADM windows to work in embedded mode.
**
** Copyright (c) 2017, Golden Code Development Corporation.
**
** _#_ _I_ __Date__ ________________________________Description__________________________________
** 001 CA  20170720 Created initial version.
-->
<!--
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
-->

<templates>
   <ast-root name="adm_embedded_case" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
     <ast id="0" text="statement" type="STATEMENT">
       <ast id="0" text="case" type="KW_CASE">
         <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
         <ast id="0" text="expression" type="EXPRESSION">
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           <ast id="0" text="pnum" type="VAR_INT">
             <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
             <annotation datatype="java.lang.Long" key="oldrefid" value="${oldrefid}"/>
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           </ast>
         </ast>
         <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
       </ast>
     </ast>
   </ast-root>

   <ast-root name="adm_embedded_page" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
     <ast id="0" text="bogus" type="BOGUS">
       <ast id="0" text="when" type="KW_WHEN">
         <ast id="0" text="expression" type="EXPRESSION">
           <ast id="0" text="${page}" type="NUM_LITERAL">
             <annotation datatype="java.lang.Boolean" key="is-literal" value="true"/>
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           </ast>
         </ast>
       </ast>
       <ast id="0" text="then" type="KW_THEN">
         <ast id="0" text="inner block" type="INNER_BLOCK">
           <ast id="0" text="do" type="KW_DO">
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           </ast>
           <ast id="0" text="block" type="BLOCK">
           </ast>
         </ast>
       </ast>
     </ast>
   </ast-root>

   <ast-root name="add_run_call" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
      <ast id="0" text="statement" type="STATEMENT">
        <ast id="0" text="run" type="KW_RUN">
          <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
          <ast id="0" text="${procName}" type="FILENAME">
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
          </ast>
          <ast id="0" text="(" type="LPARENS">
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            <ast id="0" text="parameter" type="PARAMETER">
              <ast id="0" text="expression" type="EXPRESSION">
                <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                <ast id="0" text="${handleVarName}" type="VAR_HANDLE">
                  <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
                  <annotation datatype="java.lang.Long" key="refid" value="${handleVarRefId}"/>
                  <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                </ast>
              </ast>
            </ast>
          </ast>
        </ast>
      </ast>
   </ast-root>
   
   <ast-root name="define_procedure" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
       <ast id="0" text="procedure" type="PROCEDURE">
         <ast id="0" text="procedure" type="KW_PROC">
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           <ast id="0" text="${procname}" type="SYMBOL"/>
         </ast>
         <ast id="0" text="block" type="BLOCK">
           <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
         </ast>
       </ast>
   </ast-root>

   <ast-root name="define_parameter_pnum" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
      <ast id="0" text="statement" type="STATEMENT">
        <ast id="0" text="define" type="DEFINE_PARAMETER">
          <annotation datatype="java.lang.String" key="name" value="pnum"/>
          <annotation datatype="java.lang.Long" key="oldid" value="${oldid}"/>
          <annotation datatype="java.lang.String" key="token" value="VAR_INT"/>
          <annotation datatype="java.lang.String" key="parmtoken" value="KW_INPUT"/>
          <annotation datatype="java.lang.Boolean" key="vardef" value="true"/>
          <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
          <ast id="0" text="input" type="KW_INPUT"/>
          <ast id="0" text="pnum" type="SYMBOL"/>
          <ast id="0" text="as" type="KW_AS">
            <ast id="0" text="int" type="KW_INT"/>
          </ast>
        </ast>
      </ast>
   </ast-root>

   <ast-root name="define_parameter_hnum" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
      <ast id="0" text="statement" type="STATEMENT">
        <ast id="0" text="define" type="DEFINE_PARAMETER">
          <annotation datatype="java.lang.String" key="name" value="hnum"/>
          <annotation datatype="java.lang.Long" key="oldid" value="${oldid}"/>
          <annotation datatype="java.lang.String" key="token" value="VAR_INT"/>
          <annotation datatype="java.lang.String" key="parmtoken" value="KW_OUTPUT"/>
          <annotation datatype="java.lang.Boolean" key="vardef" value="true"/>
          <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
          <ast id="0" text="input" type="KW_OUTPUT"/>
          <ast id="0" text="pnum" type="SYMBOL"/>
          <ast id="0" text="as" type="KW_AS">
            <ast id="0" text="int" type="KW_INT"/>
          </ast>
        </ast>
      </ast>
   </ast-root>

   <ast-root name="define_parameter_h_extent" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
     <ast id="0" text="statement" type="STATEMENT">
       <ast id="0" text="def" type="DEFINE_PARAMETER">
         <annotation datatype="java.lang.String" key="name" value="h"/>
         <annotation datatype="java.lang.Long" key="oldid" value="${oldid}"/>
         <annotation datatype="java.lang.String" key="token" value="VAR_HANDLE"/>
         <annotation datatype="java.lang.String" key="parmtoken" value="KW_OUTPUT"/>
         <annotation datatype="java.lang.Long" key="extent" value="100"/>
         <annotation datatype="java.lang.Boolean" key="vardef" value="true"/>
         <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
         <ast id="0" text="output" type="KW_OUTPUT"/>
         <ast id="0" text="h" type="SYMBOL"/>
         <ast id="0" text="as" type="KW_AS">
           <ast id="0" text="handle" type="KW_HANDLE"/>
         </ast>
         <ast hidden="true" id="0" line="3" text="extent" type="KW_EXTENT">
           <ast id="0" text="100" type="NUM_LITERAL">
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           </ast>
         </ast>
       </ast>
     </ast>
   </ast-root>

   <ast-root name="define_variable_fwd_embedded_driver" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
       <ast id="0" text="statement" type="STATEMENT">
         <ast id="0" text="def" type="DEFINE_VARIABLE">
           <annotation datatype="java.lang.Long" key="oldid" value="${oldid}"/>
           <annotation datatype="java.lang.String" key="name" value="fwd-driver-handle"/>
           <annotation datatype="java.lang.String" key="token" value="VAR_HANDLE"/>
           <annotation datatype="java.lang.Boolean" key="shared" value="true"/>
           <annotation datatype="java.lang.Boolean" key="global" value="true"/>
           <annotation datatype="java.lang.Boolean" key="newed" value="true"/>
           <annotation datatype="java.lang.Boolean" key="vardef" value="true"/>
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           <ast id="0" text="new" type="KW_NEW"/>
           <ast id="0" text="global" type="KW_GLOBAL"/>
           <ast id="0" text="shared" type="KW_SHARED"/>
           <ast id="0" text="fwd-driver-handle" type="SYMBOL"/>
           <ast id="0" text="as" type="KW_AS">
             <ast id="0" text="handle" type="KW_HANDLE"/>
           </ast>
         </ast>
       </ast>
   </ast-root>

   <ast-root name="check_embedded_mode" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
       <ast id="0" text="statement" type="STATEMENT">
         <ast id="0" text="if" type="KW_IF">
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           <ast id="0" text="expression" type="EXPRESSION">
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
             <ast id="0" text="valid-handle" type="FUNC_LOGICAL">
               <annotation datatype="java.lang.String" key="oldtoken" value="KW_VAL_HND"/>
               <annotation datatype="java.lang.Boolean" key="builtin" value="true"/>
               <annotation datatype="java.lang.Boolean" key="returnsunknown" value="false"/>
               <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
               <ast id="0" text="fwd-driver-handle" type="VAR_HANDLE">
                 <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
                 <annotation datatype="java.lang.Long" key="oldrefid" value="${oldrefid}"/>
                 <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
               </ast>
             </ast>
           </ast>
           <ast id="0" text="then" type="KW_THEN">
             <ast id="0" text="block" type="BLOCK">
               <ast id="0" text="statement" type="STATEMENT">
                 <ast id="0" text="return" type="KW_RETURN">
                   <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                 </ast>
               </ast>
             </ast>
           </ast>
         </ast>
       </ast>
   </ast-root>
   
   <ast-root name="run_fwdInitPages" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
       <ast id="0" text="statement" type="STATEMENT">
         <ast id="0" text="run" type="KW_RUN">
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           <ast id="0" text="fwdInitPages" type="FILENAME">
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
           </ast>
           <ast id="0" text="(" type="LPARENS">
             <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
             <ast id="0" text="parameter" type="PARAMETER">
               <ast id="0" text="expression" type="EXPRESSION">
                 <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                 <ast id="0" text=":" type="COLON">
                   <ast id="0" text="this-procedure" type="SYS_HANDLE">
                     <annotation datatype="java.lang.String" key="oldtoken" value="KW_THIS_PRC"/>
                   </ast>
                   <ast id="0" text="name" type="ATTR_CHAR">
                     <annotation datatype="java.lang.String" key="oldtoken" value="KW_NAME"/>
                     <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                   </ast>
                 </ast>
               </ast>
             </ast>
             <ast id="0" text="parameter" type="PARAMETER">
               <ast id="0" text="expression" type="EXPRESSION">
                 <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                 <ast id="0" text="${pageList}" type="STRING">
                   <annotation datatype="java.lang.Boolean" key="is-literal" value="true"/>
                   <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                 </ast>
               </ast>
             </ast>
           </ast>
         </ast>
       </ast>
   </ast-root>

   <ast-root name="function_fwdGetMainFrame" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
       <ast id="0" text="function" type="FUNCTION">
         <ast id="0" text="function" type="KW_FUNCT">
           <annotation datatype="java.lang.String" key="name" value="fwdGetMainFrame"/>
           <annotation datatype="java.lang.String" key="token" value="FUNC_HANDLE"/>
           <annotation datatype="java.lang.Boolean" key="builtin" value="false"/>
           <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
         </ast>
         <ast id="0" text="block" type="BLOCK">
           <ast id="0" text="statement" type="STATEMENT">
             <ast id="0" text="return" type="KW_RETURN">
               <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
               <ast id="0" text="expression" type="EXPRESSION">
                 <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                 <ast id="0" text=":" type="COLON">
                   <ast id="0" text="frame" type="KW_FRAME">
                     <ast id="0" text="${frameName}" type="WID_FRAME"/>
                   </ast>
                   <ast id="0" text="handle" type="ATTR_HANDLE">
                     <annotation datatype="java.lang.String" key="oldtoken" value="KW_HANDLE"/>
                     <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                   </ast>
                 </ast>
               </ast>
             </ast>
           </ast>
         </ast>
       </ast>
   </ast-root>

   <ast-root name="function_fwdGetWindow" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
    <ast id="0" text="function" type="FUNCTION">
      <ast id="0" text="function" type="KW_FUNCT">
        <annotation datatype="java.lang.String" key="name" value="fwdGetWindow"/>
        <annotation datatype="java.lang.String" key="token" value="FUNC_HANDLE"/>
        <annotation datatype="java.lang.Boolean" key="builtin" value="false"/>
        <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
      </ast>
      <ast id="0" text="block" type="BLOCK">
        <ast id="0" text="statement" type="STATEMENT">
          <ast id="0" text="return" type="KW_RETURN">
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            <ast id="0" text="expression" type="EXPRESSION">
              <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
              <ast id="0" text="${windowName}" type="VAR_HANDLE">
                <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
                <annotation datatype="java.lang.Long" key="refid" value="${windowRefId}"/>
                <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
              </ast>
            </ast>
          </ast>
        </ast>
      </ast>
    </ast>
   </ast-root>
   
   <ast-root name="assign_num_pages" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
      <ast id="0" text="assignment" type="ASSIGNMENT">
        <ast id="0" text="=" type="ASSIGN">
          <ast id="0" text="hnum" type="VAR_INT">
            <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
            <annotation datatype="java.lang.Long" key="oldrefid" value="${hnumOldRefId}"/>
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
          </ast>
          <ast id="0" text="expression" type="EXPRESSION">
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            <ast id="0" text="${pagenum}" type="NUM_LITERAL">
              <annotation datatype="java.lang.Boolean" key="is-literal" value="true"/>
              <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            </ast>
          </ast>
        </ast>
      </ast>
   </ast-root>
   
   <ast-root name="assign_page_handle" terse="true" ast_class="com.goldencode.p2j.uast.ProgressAst">
      <ast id="0" text="assignment" type="ASSIGNMENT">
        <ast id="0" text="=" type="ASSIGN">
          <ast id="0" text="h" type="VAR_HANDLE">
            <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
            <annotation datatype="java.lang.Long" key="oldrefid" value="${hOldRefId}"/>
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            <ast id="0" text="[" type="LBRACKET">
              <ast id="0" text="expression" type="EXPRESSION">
                <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                <ast id="0" text="${idx}" type="NUM_LITERAL">
                  <annotation datatype="java.lang.Boolean" key="is-literal" value="true"/>
                  <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
                </ast>
              </ast>
            </ast>
          </ast>
          <ast id="0" text="expression" type="EXPRESSION">
            <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            <ast id="0" text="${handleVarName}" type="VAR_HANDLE">
              <annotation datatype="java.lang.String" key="oldtoken" value="SYMBOL"/>
              <annotation datatype="java.lang.Long" key="refid" value="${handleVarRefId}"/>
              <annotation datatype="java.lang.Long" key="support_level" value="16400"/>
            </ast>
          </ast>
        </ast>
      </ast>
   </ast-root>
</templates>
